source: projects/vbootstrap/trunk/vbuilder.sh.in @ 5368

Revision 5368, 29.7 KB checked in by munepi, 12 years ago (diff)

DEFAULT_VERSION を廃止

RevLine 
[118]1#!/bin/bash
2# -*- coding: utf-8-unix -*-
3
[2522]4TEXTDOMAIN=vbootstrap
5TEXTDOMAINDIR=/usr/share/locale
6
[2516]7Usage(){
[118]8    cat<<EOF
[3675]9$(basename $0) @@VBUILDER_VERSION@@ $(echo $([ -z "@@VBUILDER_REVISION@@" ] || echo "(r@@VBUILDER_REVISION@@)"))
[5367]10Usage:  $(basename $0) {--profile [profile]} {--version [version]} {--arch [arch]} {--category [categories]} {--fetch-url [fetch_url]} {--dist-upgrade} {--target [target]} {--with-compat32} {--rpmbuild-define [macro_expr]} {--rpmbuild-with [bcond_with]} {--rpmbuild-without [bcond_with]} {--sign} {--no-install} {--debug} {--help} {--bootstrap-dir [directory]} {--unionfs-dir [directory]} {--cache-dir [directory]} {--built-rpms-dir [directory]} {clean|build|build-rpm [src.rpm]|install-rpm [arch.rpm|package]|remove-rpm [package]}
[4076]11EOF
[411]12
[4076]13    echo $"
[411]14Options:
[5364]15        --profile:              set a profile
[118]16        --version:              set [version] (default: ${DEFAULT_VERSION})
[2718]17        --arch:                 set [arch] (default: ${UARCH})
[791]18        --category:             set [categories] (default: ${CATEGORIES})
[5364]19        --fetch-url:            set [fetch_url] to fetch packages (default: ${VBOOTSTRAP_FETCH_URL})
[412]20        --dist-upgrade:         make VineSeed bootstrap via ${STABLE_VERSION}
[791]21        --unionfs:              cover a bootstrap with unionfs
[406]22        --target:               build rpms with [target]
[3850]23        --with-compat32:        build rpms with compat32 on bootstrap
[2531]24        --rpmbuild-define:      give a option --define [macro_expr] to rpmbuild
[1476]25        --rpmbuild-with:        give a option --with [bcond_with] to rpmbuild
[2531]26        --rpmbuild-without:     give a option --without [bcond_with] to rpmbuild
[1240]27        --sign:                 sign built rpms
[1267]28        --no-install:           build only a source rpm - do NOT install a built rpm
[2718]29        --login:                login in chroot as root user
[709]30        --bootstrap-dir:        set a bootstrap directory (default: ${VBOOTSTRAP_DIR})
[2711]31        --unionfs-dir:          set a directory to store unionfs images of vbootstrap (default: ${UNIONFS_DIR})
[725]32        --cache-dir:            set a directory to cache rpms (default: ${CACHE_DIR})
[709]33        --built-rpms-dir:       set a directory to store built rpms in chroot (default: ${BUILT_RPMS_DIR})
[2718]34        --debug:                enable debug mode
35        --help:                 show this help
[4076]36"
[411]37
[4076]38    echo $"
[411]39Actions:
[3850]40        clean:                  clean the bootstrap of [version]
41        build:                  build a bootstrap of [version]
[5367]42        build-rpm:              build [src.rpm] on a bootstrap
[3850]43        install-rpm:            install [arch.rpm|package] on a bootstrap
44        remove-rpm:             remove [package] on a bootstrap
[4076]45"
[118]46
[4076]47    echo $"
[3968]48Examples:
[304]49* make a clean/plain build environment on the current archtecture:
[802]50$(basename $0) clean build
[470]51* build rpms from the specified source rpm:
[802]52$(basename $0) build-rpm [src.rpm]
[3676]53* make a plain build environment for Vine Linux 5.2:
54$(basename $0) --version 5.2 clean build
[304]55* make a i386 chroot on x86_64:
[802]56$(basename $0) --arch i386 clean build
57* build a kernel package with target i686:
58$(basename $0) --target i686 build-rpm [kernel src.rpm]
[406]59* build a compat32 package:
[802]60$(basename $0) --arch i386 --with-compat32 build-rpm [src.rpm]
[4076]61"
62    /usr/sbin/vbootstrap | sed -e s/^Usage:.*// -e s/^E:.*//
[5364]63## TODO: output supported profiles and their names/comments
[118]64}
65
[323]66##############################################################################
67
[5364]68initialize-variables(){
69    ## set boolian variables
70    with_profile=0
71    with_setup_vbootstrap=0
72    with_dist_upgrade=0
73    with_unionfs=0
74    with_sign=0
75    with_no_install=0
76    with_login=0
77    with_debug=0
78    with_actions=0
79    with_ix86_on_x86_64=0
80    with_category_main=0
81    with_category_plus=0
82    with_category_nonfree=0
83    with_category_test=0
84    with_category_proposed_updates=0
85    with_category_security=0
86
87    return 0
88}
89
[416]90check-parameter(){
[2516]91    [ -z "$*" ] && Usage && return 1
[416]92
93    while [ ! -z "$*" ]; do
94        case $1 in
[725]95            --help|help)
[5367]96                setup-vbuilder ||:
[2516]97                Usage
[517]98                return 1
[516]99                ;;
[5364]100            --profile)
101                shift
102                with_profile=1
103                PROFILE=$1
104                check-next-parameter $1 || return 1
105                ;;
106            --version|--arch|--category|--fetch-url|--target|--rpmbuild-define|--rpmbuild-with|--rpmbuild-without|--bootstrap-dir|--unionfs-dir|--cache-dir|--built-rpms-dir)
[725]107                [ $with_actions -eq 1 ] && \
[2516]108                    echo $"E: You can give no more options after actions" && \
109                    return 1
[416]110                shift
111                check-next-parameter $1 || return 1
112                ;;
[2718]113            --dist-upgrade|--unionfs|--with-compat32|--sign|--no-install|--login|--debug)
[725]114                [ $with_actions -eq 1 ] && \
[2516]115                    echo $"E: You can give no more options after actions" && \
116                    return 1
[416]117                ;;
[725]118            --build-rpm|build-rpm|--install-rpm|install-rpm|--remove-rpm|remove-rpm)
119                with_actions=1
120                shift
121                check-next-parameter $1 || return 1
122                ;;
[3675]123            --build|build|--clean|clean)
[725]124                with_actions=1
125                ;;
[416]126            *)
[2516]127                echo $"E: Missing some parameters after $1"
[416]128                return 1
129                ;;
130        esac
131        shift
132    done
[725]133
[2516]134    [ $with_actions -eq 0 ] && \
135        echo $"E: You must give at least one action" && return 1
[725]136
[416]137    return 0
138}
139
[412]140check-next-parameter(){
[2516]141    [ -z "$1" ] && echo $"E: Missing some parameters after $1" && return 1
[416]142
[2516]143    [ $(echo $1 | grep '^-') ] && \
144        echo $"E: Missing some parameters after $1" && return 1
[725]145
[412]146    return 0
147}
148
[5364]149## NOTE: setup-vbuilder() loads
150##  - system wide configurations (from /etc/vbootstrap/vbuilder.conf)
151##  - given profile (from /etc/vbootstrap/profile.d/*.conf)
152##  - given command-line parameters
153## where given command-line parameters override the settings given profile,
154## and the settings given profile override system wide settings.
155## If you use a profile of vbuilder, you may not override the settings
156## given profile.
[323]157setup-vbuilder(){
[3343]158    ## check $SUDO_USER and $USERHELPER_UID
159    RPM_SIGN_USER=$SUDO_USER
160    if [ -z "${RPM_SIGN_USER}" ]; then
[3967]161        [ -z "${USERHELPER_UID}" ] && \
162            echo $"W: \$SUDO_USER and \$USERHELPER_UID are empty" && \
163            return 1
164           
[3352]165        RPM_SIGN_USER=$(getent passwd $USERHELPER_UID | cut -d":" -f1)
[3343]166    fi
167    ## get $RPM_SIGN_USER's home directory
168    HOME=$(getent passwd $RPM_SIGN_USER |  cut -d":" -f6)
169
[323]170    ## load default settings
[725]171    VBUILDER_CONF=/etc/vbootstrap/vbuilder.conf
172    if [ -r $VBUILDER_CONF ]; then
173        . $VBUILDER_CONF
[1240]174        [ $? -eq 1 ] && return 1
[323]175    fi
[791]176    [ -z "${CATEGORIES}" ] && \
177        CATEGORIES=@@VBUILDER_CATEGORIES@@
[5364]178    [ -z "${VBOOTSTRAP_FETCH_URL}" ] && \
179        VBOOTSTRAP_FETCH_URL=@@VBUILDER_VBOOTSTRAP_FETCH_URL@@
[330]180    [ -z "${VBOOTSTRAP_DIR}" ] && \
181        VBOOTSTRAP_DIR=@@VBUILDER_VBOOTSTRAP_DIR@@
[2711]182    [ -z "${UNIONFS_DIR}" ] && \
183        UNIONFS_DIR=@@VBUILDER_UNIONFS_DIR@@
[725]184    [ -z "${CACHE_DIR}" ] && \
185        CACHE_DIR=@@VBUILDER_CACHE_DIR@@
[370]186    [ -z "${BUILT_RPMS_DIR}" ] && \
187        BUILT_RPMS_DIR=@@VBUILDER_BUILT_RPMS_DIR@@
[709]188
[5368]189    ## set default version for vbootstrap
190    VERSION=@@VBUILDER_DEFAULT_VERSION@@
191
[5364]192    ## load profile
193    if [ ${with_profile} -eq 1 ]; then
194        [ ! -r /etc/vbootstrap/profile.d/${PROFILE}.conf ] && \
195            echo $"E: No such profile found: ${PROFILE}" && return 1
196
197        . /etc/vbootstrap/profile.d/${PROFILE}.conf
198        [ $? -eq 1 ] && return 1
199    fi
200
[709]201    ## set current stable relase version
[411]202    STABLE_VERSION=@@VBUILDER_STABLE_VERSION@@
203
[3676]204    ## set default chroot archtecture
205    UARCH=$(uname -i)
206    case "${UARCH}" in
207        arm*)
208            UARCH="arm"
209            ;;
210    esac
211
[1240]212    return 0
[323]213}
214
[118]215setup-vbootstrap(){
[411]216    if [ ${with_setup_vbootstrap} -eq 0 ]; then
217        with_setup_vbootstrap=1
[118]218
[2718]219        ## check debug mode
220        [ ${with_debug} -eq 1 ] && \
[3675]221            cat $VBUILDER_CONF && \
[2718]222            set && set -x
223
[725]224        ## check some directories
225        ## Note: create $BUILT_RPMS_DIR in RPM_Build()
[709]226        [ -d $VBOOTSTRAP_DIR ] || mkdir -p $VBOOTSTRAP_DIR
[725]227        [ -d $CACHE_DIR ] || mkdir -p $CACHE_DIR
[709]228
[3676]229        ## check chroot version
230        case ${VERSION} in
[4072]231            4.2|5.2|6.0|VineSeed)
[2718]232                ;;
[3676]233            *)
234                echo $"E: ${VERSION} is NOT supported"
235                return 1
236                ;;
[2718]237        esac
238
239        case "${VARCH}" in
240            arm*)
241                VARCH="arm"
242                ;;
243        esac
244
[304]245        ## check a chroot archtecture
[725]246        if [ -z ${VARCH} ]; then
[2718]247            VARCH=${UARCH}
[725]248        else
[304]249            case "${VARCH}" in
[3676]250                i386|x86_64)
251                    [ "${UARCH}" = "ppc" -o "${UARCH}" = "arm" ] && \
252                        echo $"E: arch ${VARCH} is NOT supported on ${UARCH}" && return 1
[304]253                    ;;
254                ppc)
[3676]255                    [ "${UARCH}" = "i386" -o "${UARCH}" = "x86_64" -o "${UARCH}" = "arm" ] && \
256                        echo $"E: arch ${VARCH} is NOT supported on ${UARCH}" && return 1
[304]257                    ;;
[2718]258                arm)
[3676]259                    [ "${UARCH}" = "i386" -o "${UARCH}" = "x86_64" -o "${UARCH}" = "ppc" ] && \
[2718]260                        echo $"E: arch ${VARCH} is NOT supported on ${UARCH}" && return 1
261                    ;;
[304]262            esac
[323]263        fi
264
[3676]265        ##!! 4.2 is NO support on VARCH=x86_64 or VARCH=arch
266        if [ "${VERSION}" = "4.2" ]; then
267            if [ "${VARCH}" = "x86_64" -o "${VARCH}" = "arm" ]; then
268                echo $"E: ${VERSION}_${VARCH} is NOT supported"
269                return 1
270            fi
[323]271        fi
272
[5364]273        ## set base profile <version>_<arch>
274        BASE_PROFILE=${VERSION}_${VARCH}
[2718]275
[5364]276        ## check support ${BASE_PROFILE}
277        if [ -z "$(/usr/sbin/vbootstrap | sed -e s/^Usage:.*// -e s/^E:.*// | grep -m 1 ${BASE_PROFILE})" ]; then
278            echo $"E: ${BASE_PROFILE} is NOT supported"
[2516]279            return 1
[323]280        fi
281
[411]282        ## check ${VERSION} equals VineSeed*, when with_dist_upgrade=1
283        if [ $with_dist_upgrade -eq 1 ]; then
[3676]284            if [ "${VERSION}" != "VineSeed" ]; then
[2516]285                echo $"E: version ${VERSION} does not support --dist-upgrade option"
286                return 1
[411]287            fi
288        fi
289
[3676]290        ## support i386 chroot on x86_64 below:
291        [ "${UARCH}" = "x86_64" -a "${VARCH}" = "i386" ] && \
292            with_ix86_on_x86_64=1
[791]293
294        ## check apt categories
[800]295        ## "main" category is unconditionally permited
[791]296        with_category_main=1
297        for cat in $(echo ${CATEGORIES} | sed -e "s/,/ /"g); do
298            case $cat in
299                main)
300                    with_category_main=1
301                    ;;
302                plus)
303                    with_category_plus=1
304                    ;;
305                nonfree)
306                    with_category_nonfree=1
307                    ;;
[800]308                test)
309                    ## "test" category only exists in VineSeed
[3676]310                    [ "${VERSION}" = "VineSeed" ] || \
[2516]311                        echo $"E: No such category exists: $cat" && return 1
[800]312                    with_category_test=1
313                    ;;
[791]314                proposed-updates)
[800]315                    ##!! "proposed-updates" category does not exist in 4.2
[3676]316                    [ "${VERSION}" = "4.2" ] && \
[2516]317                        echo $"E: No such category exists: $cat" && return 1
[791]318
319                    with_category_proposed_updates=1
320                    ;;
[800]321                security)
322                    ## "security" category does not exist in VineSeed
[3676]323                    [ "${VERSION}" = "VineSeed" ] && \
[2516]324                        echo $"E: No such category exists: $cat" && return 1
[800]325                    with_category_security=1
326                    ;;
[791]327                *)
[2516]328                    echo $"E: No such category exists: $cat" && return 1
[791]329                    ;;
330            esac
331        done
332
[406]333        ## check build target option ${TARGET}
[407]334        if [ ! -z "${TARGET}" ]; then
335            RPM_TARGET_LIST="$(cat /usr/lib/rpm/rpmrc | grep arch_canon: | sed -e "s/arch_canon:[[:blank:]]*\(.*\):.*/\1/")"
[3742]336            RPM_TARGET_LIST="${RPM_TARGET_LIST} noarch"
337            if [ -z "$(echo ${RPM_TARGET_LIST} | grep ${TARGET})" ]; then
[2516]338                echo $"E: rpm build target ${TARGET} is NOT supported"
339                return 1
[407]340            fi
[406]341        fi
342
[1240]343        ## set ${RPM_PKG_ARCH_LIST}
[5364]344        RPM_PKG_ARCH_LIST=" \
345            RPMS/i386 RPMS/i486 RPMS/i586 RPMS/i686 RPMS/x86_64 RPMS/ppc \
346            RPMS/noarch \
347            RPMS/armv3l RPMS/armv4l RPMS/armv4tl \
348            RPMS/armv5tejl RPMS/armv5tel RPMS/armv6l RPMS/armv7l \
349            SRPMS"
[1240]350        [ -z "${TARGET}" ] || \
351            RPM_PKG_ARCH_LIST="RPMS/${TARGET} ${RPM_PKG_ARCH_LIST}"
352
[135]353    fi
[323]354
[1240]355    ## set global variables
[296]356    BUILD_USER=vbuilder
357    BUILD_DIR=/home/${BUILD_USER}/rpm
[5364]358    if [ ${with_profile} -eq 1 ]; then
359        BUILD_ROOT=${VBOOTSTRAP_DIR}/${PROFILE}
360        UNIONFS_ROOT=${UNIONFS_DIR}/${PROFILE}
361    else
362        BUILD_ROOT=${VBOOTSTRAP_DIR}/${BASE_PROFILE}
363        UNIONFS_ROOT=${UNIONFS_DIR}/${BASE_PROFILE}
364    fi
[452]365    ARCHIVES_DIR=${BUILD_ROOT}/var/cache/apt/archives
[5364]366    EXTERNAL_ARCHIVES_DIR=${CACHE_DIR}/${BASE_PROFILE}/apt/archives
[135]367
[2468]368    __chroot_sh="/usr/sbin/chroot ${BUILD_ROOT} /bin/sh -c -l"
[453]369
[135]370    mkdir -p $VBOOTSTRAP_DIR
[1240]371
372    return 0
[118]373}
374
[412]375setup-vbootstrap-rpm(){
[1240]376    setup-vbootstrap || return 1
[412]377
378    ## check ${BUILD_ROOT}
379    [ -d ${BUILD_ROOT} ] || Build
[2324]380    ## setarch ix86 if ix86 chroot on x86_64 host
381    [ $with_ix86_on_x86_64 -eq 1 ] && \
[2468]382        __chroot_sh="/usr/sbin/chroot ${BUILD_ROOT} setarch ${VARCH} /bin/sh -c -l"
[412]383
384    DIST_RELEASE=$(cat ${BUILD_ROOT}/etc/vine-release | cut -f3 -d" " | cut -f1 -d.)
385
386    if [ -f $RPM_PKG ]; then
387        BASE_RPM_PKG=$(basename $RPM_PKG)
388        cp -f $RPM_PKG $BUILD_ROOT${BUILD_DIR}
389    else
390        BASE_RPM_PKG=$RPM_PKG   
391    fi
[1240]392
393    return 0
[412]394}
395
[413]396## recover apt-get data on host/chroot
397apt-get-update(){
398    case $1 in
399        --host)
[2522]400            echo -n $"apt-get update on host ... "
[464]401            apt-get -qq update > /dev/null 2>&1
[2522]402            echo $"done."
[413]403            ;;
404        --chroot)
[2522]405            echo -n $"apt-get update on chroot ... "
[464]406            $__chroot_sh 'apt-get -qq update' > /dev/null 2>&1
[2522]407            echo $"done."
[413]408            ;;
409        *)
410            echo apt-get-update: unknown option $1
411            exit 1
412            ;;
413    esac
414}
415
[454]416## mount-chroot {|--umount} [file system|name]
417## support file systems: /home /tmp /sys /proc /dev/shm /dev/pts /dev
[2654]418## support names: vfs archives_dir
[454]419## NOTE: /tmp needs for applications which use X
420##       vfs is virtual file systems
[851]421##       archives_dir uses to mount ${EXTERNAL_ARCHIVES_DIR} to ${ARCHIVES_DIR}
422##       unionfs_dir covers ${BUILD_ROOT} with unionfs
[454]423mount-chroot(){
[412]424    if [ "$1" = "--umount" ]; then
[454]425        mount-chroot-umount $2 || return 1
[412]426    else
[454]427        mount-chroot-mount $1 || return 1
[412]428    fi
[454]429    return 0
[412]430}
431
[454]432## mount-chroot-umount [file system|name]
433mount-chroot-umount(){
434    local fs=$1
435    case $fs in
436        /home|/tmp|/sys|/proc|/dev/shm|/dev/pts|/dev)
437            [ -d ${BUILD_ROOT}${fs} ] || return 1
438            [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] || \
439                umount ${BUILD_ROOT}${fs}
[2654]440            if [ ! -z "$(mount | grep ${BUILD_ROOT}${fs})" ]; then
441                echo $"Retry lazy unmount ${BUILD_ROOT}${fs} ... "
442                umount -l ${BUILD_ROOT}${fs}
443                echo $"done."
444            fi
[454]445            ;;
446        vfs)
[2718]447            for dir in /sys /proc /dev/shm /dev/pts /dev; do
448                mount-chroot-umount ${dir} || return 1
449            done
[454]450            ;;
[725]451        archives_dir)
[454]452            [ -d ${ARCHIVES_DIR} ] || return 1
453            [ -z "$(mount | grep ${ARCHIVES_DIR})" ] || \
454                umount ${ARCHIVES_DIR}
455            ;;
[485]456        unionfs_dir)
457            [ -d ${BUILD_ROOT} ] || return 1
458            [ -z "$(mount | grep ${BUILD_ROOT} | grep unionfs)" ] || \
459                umount ${BUILD_ROOT}
460            if [ ! -z "$(mount | grep ${BUILD_ROOT} | grep unionfs)" ]; then
[2654]461                echo $"Retry lazy unmount ${BUILD_ROOT} ... "
[485]462                umount -l ${BUILD_ROOT}
[2522]463                echo $"done."
[485]464            fi
465            ;;
[454]466        *)
467            echo mount-chroot-umount: unknown file system $fs
468            exit 1
469            ;;
470    esac
[1240]471    return 0
[412]472}
473
[454]474## mount-chroot-mount [file system|name]
475mount-chroot-mount(){
476    local fs=$1
[412]477
[454]478    case $fs in
479        /home)
[2718]480            [ -d ${BUILD_ROOT}${fs} ] || mkdir -p ${BUILD_ROOT}${fs}
481            [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] && \
482                mount -o _netdev,rbind ${fs} ${BUILD_ROOT}${fs}
[454]483            ;;
[2718]484        /tmp|/dev)
485            [ -d ${BUILD_ROOT}${fs} ] || mkdir -p ${BUILD_ROOT}${fs}
486            [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] && \
487                mount --bind -o _netdev ${fs} ${BUILD_ROOT}${fs}
[454]488            ;;
[2718]489        /sys)
[454]490            [ -d ${BUILD_ROOT}${fs} ] || mkdir -p ${BUILD_ROOT}${fs}
491            [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] && \
[2718]492                mount -o _netdev -t sysfs vbuildersysfs ${BUILD_ROOT}${fs}
[454]493            ;;
[2718]494        /proc)
495            [ -d ${BUILD_ROOT}${fs} ] || mkdir -p ${BUILD_ROOT}${fs}
496            [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] && \
497                mount -o _netdev -t proc vbuilderproc ${BUILD_ROOT}${fs}
498            ;;
499        /dev/shm)
500            [ -d ${BUILD_ROOT}${fs} ] || mkdir -p ${BUILD_ROOT}${fs}
501            [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] && \
502                mount -o _netdev -t tmpfs vbuildertmpfs ${BUILD_ROOT}${fs}
503            ;;
504        /dev/pts)
505            [ -d ${BUILD_ROOT}${fs} ] || mkdir -p ${BUILD_ROOT}${fs}
506            [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] && \
507                mount -o gid=5,mode=620,_netdev -t devpts vbuilderdevpts ${BUILD_ROOT}${fs}
508            ;;
[454]509        vfs)
[2718]510            for dir in /dev /dev/pts /dev/shm /proc /sys; do
511                mount-chroot-mount ${dir} || return 1
512            done
[454]513            ;;
[725]514        archives_dir)
515            [ -d ${EXTERNAL_ARCHIVES_DIR} ] || mkdir -p ${EXTERNAL_ARCHIVES_DIR}
[454]516            [ -d ${ARCHIVES_DIR} ] || mkdir -p ${ARCHIVES_DIR}
517            [ -z "$(mount | grep ${ARCHIVES_DIR})" ] && \
[2718]518                mount --bind -o _netdev ${EXTERNAL_ARCHIVES_DIR} ${ARCHIVES_DIR}
[454]519            [ -d ${ARCHIVES_DIR}/partial ] || mkdir -p ${ARCHIVES_DIR}/partial
520            ;;
[485]521        unionfs_dir)
522            if [ $with_unionfs -eq 1 ]; then
[2711]523                [ -d ${UNIONFS_ROOT} ] || mkdir -p ${UNIONFS_ROOT}
[2766]524                [ -z "$(mount | grep ${UNIONFS_ROOT})" ] && \
[2711]525                    mount -t unionfs -o dirs=${UNIONFS_ROOT}=rw:${BUILD_ROOT}=ro unionfs ${BUILD_ROOT}
[485]526                unionctl ${BUILD_ROOT} --list
527            fi
528            ;;
[455]529        *)
530            echo mount-chroot-mount: unknown file system $fs
531            exit 1
532            ;;
[454]533    esac
[1240]534    return 0
[452]535}
[412]536
[5364]537## TODO: support spec-validator
538## spec-validator [spec file]
539spec-validator(){
540    echo
541    return 0
542}
[791]543
[5364]544
[118]545##############################################################################
546
547Clean(){
[1240]548    setup-vbootstrap || return 1
[118]549
[454]550    # mount-chroot --umount /home
[2718]551    mount-chroot --umount /tmp
552    mount-chroot --umount /dev/shm
553    mount-chroot --umount /dev/pts
[3021]554    mount-chroot --umount /proc
[725]555    mount-chroot --umount archives_dir
[485]556    mount-chroot --umount unionfs_dir
[413]557    apt-get-update --host
[406]558
[2770]559    ## We remark that we first remove /, and secondly remove /.
[2769]560    ## If we directly remove /, we obtained some non-empty directories:
561    ##   /dev/.udev/rules.d.
[485]562    if [ $with_unionfs -eq 1 ]; then
[2711]563        if [ -d ${UNIONFS_ROOT} ]; then
564            echo -n $"Cleaning build root ${UNIONFS_ROOT} via unionfs ... "
[2770]565            rm -rf ${UNIONFS_ROOT} 2>/dev/null
[2711]566            rm -rf ${UNIONFS_ROOT}
[2522]567            echo $"done."
[485]568        fi
569    else
570        if [ -d ${BUILD_ROOT} ]; then
[2522]571            echo -n $"Cleaning build root ${BUILD_ROOT} ... "
[2770]572            rm -rf ${BUILD_ROOT} 2>/dev/null
[485]573            rm -rf ${BUILD_ROOT}
[2522]574            echo $"done."
[485]575        fi
[323]576    fi
[412]577
[5364]578    echo $"Cleanup a build farm for ${BUILD_ROOT} done."
[1240]579    return 0
[118]580}
581
582Build(){
[1240]583    setup-vbootstrap || return 1
[118]584
[411]585    if [ $with_dist_upgrade -eq 1 ]; then
586        ## make bootstrap of ${STABLE_VERSION}
587        /usr/sbin/vbootstrap \
[5364]588            $(echo ${BASE_PROFILE} | sed -e "s/VineSeed/${STABLE_VERSION}/") \
589            ${VBOOTSTRAP_FETCH_URL} ${BUILD_ROOT}
[118]590
[411]591        ## aim apt-line to VineSeed
592        sed -i "s/apt ${STABLE_VERSION}/apt VineSeed/g" \
593            ${BUILD_ROOT}/etc/apt/sources.list.d/main.list
594    else
[5364]595        /usr/sbin/vbootstrap ${BASE_PROFILE} ${VBOOTSTRAP_FETCH_URL} ${BUILD_ROOT}
[411]596    fi
597
[2718]598    mount-chroot /proc
[725]599    mount-chroot archives_dir
[2718]600    mount-chroot /dev/pts
601    mount-chroot /dev/shm
[454]602    # mount-chroot /tmp
603    # mount-chroot /home
[118]604
[791]605    ##!! 4.2 has no apt-sourceslist-{plus,nonfree,proposed-updates} packages
[3676]606    case ${VERSION} in
[791]607        4.2)
[5364]608            sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list
609            sed -i -e 's/main plus updates nonfree *$/$(echo ${CATEGORIES} | sed -e "s/,/ /"g) updates/g' ${BUILD_ROOT}/etc/apt/sources.list
610            $__chroot_sh 'apt-get -qq update && apt-get -qq -y dist-upgrade'
[800]611            # [ $with_category_security -eq 1 ] && \
612            #   echo
[791]613            ;;
[4530]614        5.2|@@VBUILDER_STABLE_VERSION@@)
[5364]615            sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list.d/main.list
616            $__chroot_sh 'apt-get -qq update && apt-get -qq -y dist-upgrade'
[791]617            [ $with_category_plus -eq 1 ] && \
[5364]618                $__chroot_sh 'apt-get -qq update && apt-get -qq -y install apt-sourceslist-plus' && \
619                sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list.d/plus.list
[791]620            [ $with_category_nonfree -eq 1 ] && \
[5364]621                $__chroot_sh 'apt-get -qq update && apt-get -qq -y install apt-sourceslist-nonfree' && \
622                sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list.d/nonfree.list
[791]623            [ $with_category_proposed_updates -eq 1 ] && \
[5364]624                $__chroot_sh 'apt-get -qq update && apt-get -qq -y install apt-sourceslist-proposed-updates' && \
625                sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list.d/proposed-updates.list
[800]626            # [ $with_category_security -eq 1 ] && \
627            #   echo
[791]628            ;;
629        VineSeed)
[5364]630            sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list.d/main.list
631            $__chroot_sh 'apt-get -qq update && apt-get -qq -y dist-upgrade'
[791]632            [ $with_category_plus -eq 1 ] && \
[5364]633                $__chroot_sh 'apt-get -qq update && apt-get -qq -y install apt-sourceslist-plus' && \
634                sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list.d/plus.list
[791]635            [ $with_category_nonfree -eq 1 ] && \
[5364]636                $__chroot_sh 'apt-get -qq update && apt-get -qq -y install apt-sourceslist-nonfree' && \
637                sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list.d/nonfree.list
[800]638            [ $with_category_test -eq 1 ] && \
[5364]639                $__chroot_sh 'apt-get -qq update && apt-get -qq -y install apt-sourceslist-test' && \
640                sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list.d/test.list
[791]641            ;;
642    esac
[423]643
[791]644    [ $with_dist_upgrade -eq 1 ] && \
[464]645        $__chroot_sh 'apt-get -qq update && apt-get -qq -y dist-upgrade'
[791]646
[464]647    $__chroot_sh 'apt-get -qq -y install build-essential'
648    $__chroot_sh 'apt-get -qq -y install etcskel shadow-utils'
[118]649
[2662]650    $__chroot_sh 'cd /dev && /sbin/MAKEDEV console'
[2718]651    $__chroot_sh 'cd /dev && /sbin/MAKEDEV ptmx'
[2662]652    $__chroot_sh 'cd /dev && /sbin/MAKEDEV null'
653    $__chroot_sh 'cd /dev && /sbin/MAKEDEV zero'
654    $__chroot_sh 'cd /dev && /sbin/MAKEDEV random'
655    $__chroot_sh 'cd /dev && /sbin/MAKEDEV urandom'
[2718]656    $__chroot_sh 'cd /dev && mkdir -p shm && chmod 777 shm'
657    $__chroot_sh 'cd /dev && mkdir -p pts && chmod 755 pts'
[406]658
[453]659    $__chroot_sh '/usr/sbin/pwconv'
660    $__chroot_sh "/usr/sbin/useradd ${BUILD_USER}"
[323]661
[452]662    ##!! for rpm-4.8.0 or higher
663    ##!! (See http://trac.vinelinux.org/wiki/Vine6/AboutUpdateToolchain)
[3676]664    if [ "${VERSION}" = "VineSeed" ]; then
[453]665        $__chroot_sh "sed -i -e 's/^%_topdir/#%_topdir/' /home/${BUILD_USER}/.rpmmacros"
[452]666    fi
667
[5364]668    ## set local repositories (profile only)
669    if [ ${with_profile} -eq 1 ]; then
670        if [ ! -z "${LOCAL_REPOS}" ]; then
671            cat >${BUILD_ROOT}/etc/apt/sources.list.d/local.list<<EOF
672${LOCAL_REPOS}
673EOF
674        fi
675
676        $__chroot_sh "apt-get update"
677
678        ## additional base packages
679        [ ! -z "${ADD_BASE_PKGS}" ] && \
680            $__chroot_sh "apt-get -y install ${ADD_BASE_PKGS}" 
681    fi
682
[454]683    # mount-chroot --umount /home
684    # mount-chroot --umount /tmp
[2718]685    mount-chroot --umount /dev/shm
686    mount-chroot --umount /dev/pts
[725]687    mount-chroot --umount archives_dir
[2718]688    mount-chroot --umount /proc
[413]689    apt-get-update --host
[412]690
[5364]691    echo $"Making a build farm for ${BUILD_ROOT} done."
[1240]692    return 0
[118]693}
694
695RPM_Remove(){
[1240]696    setup-vbootstrap-rpm || return 1
[485]697    mount-chroot unionfs_dir
[725]698    mount-chroot archives_dir
[3021]699    mount-chroot /proc
[2718]700    mount-chroot /dev/pts
701    mount-chroot /dev/shm
[628]702    apt-get-update --chroot
[118]703
[2516]704    [ -f $RPM_PKG ] && \
705        echo $"E: $RPM_PKG is not a package name" && return 1
[453]706    $__chroot_sh "apt-get -y remove $BASE_RPM_PKG"
[412]707
[2718]708    mount-chroot --umount /dev/shm
709    mount-chroot --umount /dev/pts
[3021]710    mount-chroot --umount /proc
[725]711    mount-chroot --umount archives_dir
[485]712    mount-chroot --umount unionfs_dir
[413]713    apt-get-update --host
[1240]714
715    return 0
[118]716}
717
718RPM_Install(){
[1240]719    setup-vbootstrap-rpm || return 1
[485]720    mount-chroot unionfs_dir
[725]721    mount-chroot archives_dir
[3021]722    mount-chroot /proc
[2718]723    mount-chroot /dev/pts
724    mount-chroot /dev/shm
725
[413]726    apt-get-update --chroot
[118]727
[4622]728    [ $with_category_nonfree -eq 1 ] && \
729        [ ! -z "$(echo $BASE_RPM_PKG | grep -e 'self-build-' -e 'install-assist-')" ] && \
730        $__chroot_sh 'rpm -q --quiet self-build-setup || apt-get -qq -y install self-build-setup'
731
[453]732    $__chroot_sh "cd ${BUILD_DIR} && apt-get -y install $BASE_RPM_PKG"
[412]733
[2718]734    mount-chroot --umount /dev/shm
735    mount-chroot --umount /dev/pts
[3021]736    mount-chroot --umount /proc
[725]737    mount-chroot --umount archives_dir
[485]738    mount-chroot --umount unionfs_dir
[413]739    apt-get-update --host
[1240]740
741    return 0
[118]742}
743
744RPM_Build(){
[5364]745    [ ! -f ${RPM_PKG} ] && \
746        echo $"E: No such file found: ${RPM_PKG}" && return 1
747
748    ## check the extension of given $RPM_PKG
749    local RPM_PKG_EXT=${RPM_PKG##*.}
750    case ${RPM_PKG_EXT} in
751        spec)
752            ## In this case,
753            ## the file ${RPM_PKG} is a spec file!
754            # spec-validator ${RPM_PKG} || return 1
755            # return 1
756
757            ## We assign the variable ${RPM_PKG}
758            ## the src.rpm generated by the spec file ${RPM_PKG}.
759            RPM_PKG=$(rpm -E "%{_srcrpmdir}")/$(rpm -q --qf "%{name}-%{version}-%{release}\n" --specfile ${RPM_PKG} | head -n 1).src.rpm
760            ;;
761        rpm)
762            RPM_PKG_EXT=$(echo ${RPM_PKG} | sed -e "s|.*\.\(src\.rpm\)$|\1|")
763            [ "${RPM_PKG_EXT}" != "src.rpm" ] && \
764                echo $"E: $RPM_PKG is NOT a source RPM package" && return 1
765            ;;
766        *)
767            echo $"The action build-rpm cannot work such extension: ${RPM_PKG_EXT}"
768            return 1
769            ;;
770    esac
771
[1240]772    setup-vbootstrap-rpm || return 1
[485]773    mount-chroot unionfs_dir
[725]774    mount-chroot archives_dir
[3021]775    mount-chroot /proc
[2718]776    mount-chroot /dev/pts
777    mount-chroot /dev/shm
[628]778    apt-get-update --chroot
[5364]779   
780    [ ! -f ${RPM_PKG} ] && \
781        echo $"E: No such file found: ${RPM_PKG}" && return 1
[118]782
[370]783    RPM_PKG_USER=$(stat -c %U $RPM_PKG)
[371]784    RPM_PKG_GROUP=$(stat -c %G $RPM_PKG)
[520]785    [ ! -z "${SUDO_UID}" ] && RPM_PKG_USER=${SUDO_UID}
786    [ ! -z "${SUDO_GID}" ] && RPM_PKG_GROUP=${SUDO_GID}
[371]787    local __install="install -p -v -o ${RPM_PKG_USER} -g ${RPM_PKG_GROUP}"
[370]788
789    ## make src.rpm for $VERSION
[453]790    $__chroot_sh "cd ${BUILD_DIR} && su ${BUILD_USER} -c 'rpm -ivh $BASE_RPM_PKG'"
[1524]791    $__chroot_sh "cd ${BUILD_DIR} && su ${BUILD_USER} -c 'rpmbuild -bs --nodeps --clean --rmsource --rmspec $RPM_OPTS ${BUILD_DIR}/SPECS/*.spec'"
[370]792
[396]793
794    ## change ${DIST_RELEASE}
[4003]795    BASE_RPM_PKG=$(echo $BASE_RPM_PKG | sed -e "s/vl[0-9]*\([A-Za-z]*[0-9A-Za-z]*\)\./vl${DIST_RELEASE}\1\./")
[396]796
797    ## rebuild $BASE_RPM_PKG on ${DIST_RELEASE}
[969]798    $__chroot_sh "cd ${BUILD_DIR}/SRPMS && apt-get -o APT::Install::Virtual=true -y build-dep $BASE_RPM_PKG"
[453]799    $__chroot_sh "cd ${BUILD_DIR}/SRPMS && su ${BUILD_USER} -c 'rpmbuild --rebuild $RPM_OPTS $BASE_RPM_PKG'"
[4622]800
801    BUILT_RPMS_LIST=$(find $BUILD_ROOT${BUILD_DIR}/RPMS -type f -regex '.*\.rpm' | sed -e s@${BUILD_ROOT}@@g -e 's|.*\/compat32-.*||g' -e 's|.*\/.*\.src\.rpm||g' -e 's/$/ \\/g')
802
803    [ $with_category_nonfree -eq 1 ] && \
804        [ ! -z "$(echo $BUILT_RPMS_LIST | grep -e 'self-build-' -e 'install-assist-')" ] && \
805        $__chroot_sh 'rpm -q --quiet self-build-setup || apt-get -qq -y install self-build-setup'
806
[1267]807    [ $with_no_install -eq 0 ] && \
[4622]808        $__chroot_sh "cd ${BUILD_DIR} && apt-get -y install $BUILT_RPMS_LIST"
[396]809
[370]810    ## copy built rpms to ${HOME}/rpm/ for each archtectures
[2522]811    echo $"Copying built rpms to ${BUILT_RPMS_DIR} for each archtectures ... "
[4076]812    for i in $RPM_PKG_ARCH_LIST; do
813        [ -d $BUILD_ROOT${BUILD_DIR}/${i} ] || continue
814        if [ ! -d ${BUILT_RPMS_DIR}/${VERSION}/${i} ]; then
815            $__install -d ${BUILT_RPMS_DIR}/${VERSION}/${i}/
816            chown -R ${RPM_PKG_USER}:${RPM_PKG_GROUP} ${BUILT_RPMS_DIR}
[370]817        fi
[4076]818        find $BUILD_ROOT${BUILD_DIR}/${i} -type f -regex '.*\.rpm' \
819            -exec $__install -m0644 {} ${BUILT_RPMS_DIR}/${VERSION}/${i}/ \;
[370]820    done
[412]821
[2718]822    mount-chroot --umount /dev/shm
823    mount-chroot --umount /dev/pts
[3021]824    mount-chroot --umount /proc
[725]825    mount-chroot --umount archives_dir
[485]826    mount-chroot --umount unionfs_dir
[413]827    apt-get-update --host
[412]828
[2522]829    echo $"done."
[1240]830    return 0
[118]831}
832
[1240]833RPM_Sign(){
[1375]834    [ $with_sign -eq 1 ] || return 1
[118]835
[2668]836    setup-vbootstrap || return 1
837
838    [ -d ${BUILD_ROOT} ] || Build
839
840    mount-chroot unionfs_dir
841
[2662]842    echo $"Signing built rpms using ${RPM_SIGN_USER}'s key: "
[5364]843    su $RPM_SIGN_USER -c "rpmsign --addsign $(for i in $RPM_PKG_ARCH_LIST; do find $BUILD_ROOT${BUILD_DIR}/${i} -type f -regex '.*\.rpm' 2>/dev/null; done | sed -e s,$BUILD_ROOT${BUILD_DIR},${BUILT_RPMS_DIR}/${VERSION},g -e 's/$/ \\/g')"
[1375]844
[2668]845    mount-chroot --umount unionfs_dir
846
[1240]847    return 0
848}
849
[2718]850Login_Chroot(){
851    [ $with_login -eq 1 ] || return 1
[1240]852
[2718]853    setup-vbootstrap || return 1
854
855    __chroot="/usr/sbin/chroot ${BUILD_ROOT}"
856    ## setarch ix86 if ix86 chroot on x86_64 host
857    [ $with_ix86_on_x86_64 -eq 1 ] && \
858        __chroot="/usr/sbin/chroot ${BUILD_ROOT} setarch ${VARCH}"
859
860
861    mount-chroot unionfs_dir
862    mount-chroot archives_dir
[3021]863    mount-chroot /proc
[2718]864    mount-chroot /dev/pts
865    mount-chroot /dev/shm
866    mount-chroot /tmp
867    # mount-chroot /home
868    apt-get-update --chroot
869
870    ## copy host's configurations of /etc
871    #passwd shadow group gshadow
872    for i in resolv.conf hosts; do
873        cp -pf /etc/${i} ${BUILD_ROOT}/etc
874    done
875    cp -Ppf /etc/localtime ${BUILD_ROOT}/etc
876
[3678]877    $__chroot /bin/bash
[2718]878
879    # mount-chroot  --umount /home
880    mount-chroot  --umount /tmp
881    mount-chroot --umount /dev/shm
882    mount-chroot --umount /dev/pts
[3021]883    mount-chroot --umount /proc
[2718]884    mount-chroot --umount archives_dir
885    mount-chroot --umount unionfs_dir
886    apt-get-update --host
887
888    return 0
889}
890
891
[304]892##############################################################################
893
[5364]894initialize-variables || exit 1
[304]895
[416]896check-parameter $* || exit 1
897
[5364]898setup-vbuilder || exit 1
899
[118]900while [ $# -gt 0 ]; do
[411]901    tmpARG=$1
902    case $tmpARG in
[5364]903        --profile)
[406]904            shift
905            ;;
[5364]906        --version|--arch|--category|--fetch-url|--target|--rpmbuild-define|--rpmbuild-with|--rpmbuild-without|--bootstrap-dir|--unionfs-dir|--cache-dir|--built-rpms-dir)
907            shift
908            ;;
[2718]909        --dist-upgrade|--unionfs|--with-compat32|--sign|--no-install|--login|--debug)
[406]910            ;;
[725]911        --build-rpm|build-rpm|--install-rpm|install-rpm|--remove-rpm|remove-rpm)
912            shift
913            ;;
[3675]914        --build|build|--clean|clean)
[725]915            ;;
[406]916        *)
[416]917            echo unknown option $1
[406]918            exit 1
919            ;;
920    esac
921
[411]922    case $tmpARG in
[5364]923        --profile)
924            ;;
[406]925        --version)
[118]926            VERSION=$1
927            ;;
928        --arch)
929            VARCH=$1
930            ;;
[791]931        --category)
932            CATEGORIES=$1
933            ;;
[5364]934        --fetch-url)
935            VBOOTSTRAP_FETCH_URL=$1
936            ;;
[411]937        --dist-upgrade)
938            with_dist_upgrade=1
939            ;;
[485]940        --unionfs)
941            with_unionfs=1
942            ;;
[406]943        --target)
944            TARGET=$1
945            RPM_OPTS="${RPM_OPTS} --target $TARGET"
946            ;;
[118]947        --with-compat32)
[406]948            RPM_OPTS="${RPM_OPTS} --with compat32"
[118]949            ;;
[2531]950        --rpmbuild-define)
951            RPM_OPTS="${RPM_OPTS} --define $1"
952            ;;
[1476]953        --rpmbuild-with)
954            RPM_OPTS="${RPM_OPTS} --with $1"
955            ;;
[2531]956        --rpmbuild-without)
957            RPM_OPTS="${RPM_OPTS} --without $1"
958            ;;
[1240]959        --sign)
960            with_sign=1
961            ;;
[1267]962        --no-install)
963            with_no_install=1
964            ;;
[2718]965        --login)
966            with_login=1
967            ;;
[709]968        --bootstrap-dir)
969            VBOOTSTRAP_DIR=$1
970            ;;
[2711]971        --unionfs-dir)
972            UNIONFS_DIR=$1
973            ;;
[725]974        --cache-dir)
975            CACHE_DIR=$1
976            ;;
[709]977        --built-rpms-dir)
978            BUILT_RPMS_DIR=$1
979            ;;
[2718]980        --debug)
981            with_debug=1
982            ;;
[679]983        --build-rpm|build-rpm)
[118]984            RPM_PKG=$1
[406]985            RPM_Build || exit 1
[118]986            ;;
[679]987        --install-rpm|install-rpm)
[118]988            RPM_PKG=$1
[406]989            RPM_Install || exit 1
[118]990            ;;
[679]991        --remove-rpm|remove-rpm)
[118]992            RPM_PKG=$1
[406]993            RPM_Remove || exit 1
[118]994            ;;
[679]995        --build|build)
[1240]996            Build || exit 1
[118]997            ;;
[679]998        --clean|clean)
[1240]999            Clean || exit 1
[118]1000            ;;
1001    esac
1002    shift
1003done
1004
[3479]1005RPM_Sign ||:
[1240]1006
[3479]1007Login_Chroot ||:
[2718]1008
[118]1009exit
Note: See TracBrowser for help on using the repository browser.